Mapstats CZFMap Mod
===================
Extension for adding new markers and statuses to the Mapstats like on the CZFree Map (https://mapa.czfree.net/)

(c) 2024 by Jirka Klir (jklir[at]volny.cz)
More informations can be found on https://www.jklir.net/mapstats.html 

## Markers for nodes: 

* unknown
* infopoint
* switch
* client
* router
* ap
* ap2


## Statuses for nodes:

* 0 - inactive
* 1 - active
* 2 - testing
* 3 - under construction
* 4 - planning
* 5 - obsolete


## How to install:

* backup default markers directory in the Mapstats directory
* copy markers directory from this archive to the Mapstats directory
* open file czfmap-to-mapstats/index.php and change $polygon array with GPS positions and other options
* open https://mapa.czfree.net/ in the browser and log in (if you are not logged in, you may not get all the nodes and links)
* run czfmap-to-mapstats/index.php
* open generated URL in the browser and save JSON file to czfmap-to-mapstats/data.txt
* run again czfmap-to-mapstats/index.php - this regenerate data files (if $exportFiles is set to true)
* copy files name.nodes and name.links to the Mapstats directory --OR-- copy the generated texts directly to name.nodes and name.links in the Mapstats directory
* update Mapstats options:
```javascript
markers: {
    /* sort by priority from low to high */
    unknown: {
         name: 'Unknown',
         width: 14,
         height: 14,
         ignoreNodeStatus: true
    },
    infopoint: {
         name: 'Infopoint',
         width: 14,
         height: 14,
         ignoreNodeStatus: true
    },
    switch: {
         name: 'Switch',
         width: 12,
         height: 12,
         ignoreNodeStatus: true,
         disableTooltips: true
    },
    client: {
         name: 'Client',
         width: 14,
         height: 14
    },
    router: {
         name: 'Router',
         width: 17,
         height: 17
    },
    ap: {
        name: 'Access Point',
        width: 17,
        height: 17
    },
    ap2: {
        name: 'Open Access Point',
        width: 17,
        height: 17
    }
},
legend: {
    links: 'used',
    markers: 'all',
    statuses: [0, 1, 2, 3, 4, 5],
    statusesMarker: 'client',
    defaultMarkerStatus: 1
}
```

* open Mapstats page and see the result :-)

