<?php

// start point and end point MUST be the same = polygon must be closed!
// use mapy.cz or other map servises for defining polygon
$polygon = [
    // Kobylisy, Chabry, Čimice
    [50.1439483, 14.4310706],
    [50.1330561, 14.4301264],
    [50.1276639, 14.4342464],
    [50.1202350, 14.4488375],
    [50.1173733, 14.4690078],
    [50.1401531, 14.5009367],
    [50.1394378, 14.4635144],
    [50.1527483, 14.4610253],
    [50.1533533, 14.4344181],
    [50.1439483, 14.4310706]
];

// DEPRECATED! Not supported in the future
$network = ""; // 18 = Jablonka

$ignoreClients = false;
$clientNodeTypes = ["unknown", "client", "infopoint"];
$ignoreLinkToSomewhere = true; // links started/ended only with GPS coordinates - ignore links to nodes outside the polygon if not node in $allowNodes array
$ignoreInPlanningLinks = true;
$ignoreClientInPlanningLinks = false;
$allowInPlanningLinks = ["Unreal*Havrankova", "Unreal*Elleder", "Lemming*Elleder", "simunkova14*BD Bříza", "javorova_a1*jab352", "javorova_a1*daha", "mata j*Duch", "Modrin*Duch", "david_l*dablicka1a", "Pospa*Freedom242", "Žernosecká*beach", "roudnicka1*jab352", "wialadvi*strelnicna", "teplicka*jitrnew"];
$ignoreNodes = ["AK47", "Machar", "radimchlubna", "MaM2", "cm3", "cm29", "ns11", "Curtis", "TB-CZ-JK.gw", "cznet-skalnicka"];
$allowNodes = ["Bláha", "Kozel", "chrastavska", "Kocvara", "vlada-strizkov", "KozliHnizdo", "jitrnew", "sokolovna.habarticka", "teplicka", "t265", "jab352", "jab355", "sluknovska", "jabu", "yenik", "jabtoc", "jablonecka", "jablonka", "Mlaskovi", "Asistent", "Fíkdobrotivý", "Večerka"];
$forceChangeNodeType = ["Erik" => "client", "kn2v" => "client", "zernojelin" => "switch"];
/*$aditionalNodes = [
    [
        "name" => "Čakovice",
        "lat" => 50.1508624077,
        "lng" => 14.5261672922,
        "type" => "ap2",
        "status" => 1
    ],
    [
        "name" => "pavlabenese",
        "lat" => 50.138866001166,
        "lng" => 14.519455879927,
        "type" => "router",
        "status" => 1
    ],
    [
        "name" => "marab",
        "lat" => 50.132458464913,
        "lng" => 14.551258832216,
        "type" => "router",
        "status" => 1
    ],
    [
        "name" => "frydecka",
        "lat" => 50.138334794534,
        "lng" => 14.507782906294,
        "type" => "ap",
        "status" => 1
    ]
];*/

$exportFiles = true;
$exportName = "name";
$exportPath = "./";

// ####################################################
// don't edit code below

$bounds = [
    "west" => null,
    "north" => null,
    "south" => null,
    "east" => null
];

foreach($polygon as $key => $gps) {
    if ($bounds["south"] > $gps[0] || is_null($bounds["south"])) { $bounds["south"] = $gps[0]; }
    if ($bounds["north"] < $gps[0] || is_null($bounds["north"])) { $bounds["north"] = $gps[0]; }
    if ($bounds["west"] > $gps[1] || is_null($bounds["west"])) { $bounds["west"] = $gps[1]; }
    if ($bounds["east"] < $gps[1] || is_null($bounds["east"])) { $bounds["east"] = $gps[1]; }
}

if (empty($network) == false) {
    $network = "&nodes[network_include][0]=" . $network;
}
$urldata = "&north=".$bounds["north"]."&east=".$bounds["east"]."&south=".$bounds["south"]."&west=".$bounds["west"]."&nodes[status_exclude][0]=90&nodes[type_exclude][0]=97&nodes[type_exclude][1]=99&links[media_exclude][0]=5&links[media_exclude][1]=11&addresses[exclude_all]=1" . $network;
$urldata = str_replace(array("[", "]"), array("%5B", "%5D"), $urldata);

$url = "https://mapa.czfree.net/index.php?request=data" . $urldata;

echo "<strong>Log in to mapa.czfree.net, open this URL and save it to data.txt file:</strong><br>";
echo $url . "<br><br>\n\n";

include('pointLocation.class.php');
$pointLocation = new pointLocation();

$file = file_get_contents("data.txt");
//$file = file_get_contents($url); // if you are not logged in (get with PHP), you can miss some stricted nodes
$json = json_decode($file);

$json_nodes = $json->nodes;
$json_links = $json->links;

$nodes = [];
$links = [];

function latlngToNode($nodes, $lat, $lng) {
    $name = $lat . "," . $lng;
    foreach($nodes as $key2 => $value2) {
        if (($value2->lat . "," . $value2->lng) === $name) {
            $name = str_replace("*", "-", $value2->name);
            break;
        }
    }
    return trim($name);
}

function isAllowedLink($name1, $name2, $allowedLinks) {
    $result = false;
    if (empty($allowedLinks) == false && is_array($allowedLinks)) {
        foreach($allowedLinks as $key2 => $value2) {
            $names = explode('*', $value2);
            if (($name1 == $names[0] || $name1 == $names[1]) && ($name2 == $names[0] || $name2 == $names[1])) {
                $result = true;
                break;
            }
        }
    }
    return $result;
}

function isNodesExists($name1, $name2, $nodes) {
    $result = 0;
    if (strpos($name1, ",") !== false) {
        $result++;
    } else {
        foreach($nodes as $key2 => $value2) {
            if ($value2->name == $name1) {
                $result++;
            }
        }
    }
    if (strpos($name2, ",") !== false) {
        $result++;
    } else {
        foreach($nodes as $key2 => $value2) {
            if ($value2->name == $name2) {
                $result++;
            }
        }
    }
    if ($result >= 2) {
        return true;
    } else {
        return false;
    }
}


foreach($json_nodes as $key => $value) {
    $typeReplace = array("0" => "unknown", "1" => "client", "9" => "ap2", "10" => "ap", "11" => "router", "98" => "infopoint", "97" => "unknown", "99" => "nonczf");
    if (isset($typeReplace[$value->type])) {
        $value->type = $typeReplace[$value->type];
    }
    
    $statusReplace = array("0" => "0", "1" => "1", "10" => "0", "40" => "2", "79" => "3", "80" => "4", "90" => "5");
    if (isset($statusReplace[$value->status])) {
        $value->status = $statusReplace[$value->status];
    }
    $value->name = trim($value->name);
    
    if (empty($forceChangeNodeType) == false && is_array($forceChangeNodeType)) {
        if (array_key_exists($value->name, $forceChangeNodeType)) {
            $value->type = $forceChangeNodeType[$value->name];
        }
    }
    
    $cond = !$ignoreClients || (empty($clientNodeTypes) || in_array($value->type, $clientNodeTypes) == false);
    $cond2 = empty($ignoreNodes) || (is_array($ignoreNodes) && !in_array($value->name, $ignoreNodes));
    $cond3 = (count($polygon) == 2 || (count($polygon) > 2 && $pointLocation->pointInPolygon([$value->lat, $value->lng], $polygon) != "outside") || in_array($value->name, $allowNodes));
    if ($cond && $cond2 && $cond3) {
        $nodes[] = $value;
    }
}
if (empty($aditionalNodes) == false && is_array($aditionalNodes)) {
   foreach($aditionalNodes as $key => $value) {
       $nodes[] = (object) $value;
   }
}


foreach($json_links as $key => $value) {
    $links[] = $value;
}



echo "<strong>Nodes:</strong><br>\n";

$exportText =  "############################\n";
$exportText .= "# Name;Lat;Lng;Type;Status #\n";
$exportText .= "############################\n";
foreach($nodes as $key => $value) {
    $exportText .= $value->name . ";" . $value->lat . ";" . $value->lng . ";" . $value->type .  ";" . $value->status . "\n";
}

echo "<pre>" . $exportText . "</pre>";
if ($exportFiles) {
    file_put_contents($exportPath . $exportName . ".nodes", $exportText);
}

echo "\n\n<br><br>";

echo "<strong>Links:</strong><br>\n";

$exportText =  "##################################################\n";
$exportText .= "# Name1*Name2[*Lat,Lng];LinkType;Backbone;Active #\n";
$exportText .= "##################################################\n";
foreach($links as $key => $value) {
    $name1 = latlngToNode($nodes, $value->lat1, $value->lng1);
    $name2 = latlngToNode($nodes, $value->lat2, $value->lng2);
    $medium = $value->media;
    $backbone = $value->backbone;
    $active = $value->active;
    if (strpos($name1, ",") !== false && strpos($name2, ",") !== false) {
    } else {
        $cond = !$ignoreLinkToSomewhere || (strpos($name1, ",") === false && strpos($name2, ",") === false);
        $cond2 = !$ignoreInPlanningLinks || ($active == "1" || isAllowedLink($name1, $name2, $allowInPlanningLinks));
        $cond3 = !$ignoreClientInPlanningLinks || (($active == "1" || $backbone == "1") || isAllowedLink(trim($name1), trim($name2), $allowInPlanningLinks));
        $cond4 = isNodesExists($name1, $name2, $nodes);
        if ($cond && $cond2 && $cond3 && $cond4) {
            $exportText .= $name1 . "*" . $name2 . ";" . $medium .  ";" . $backbone . ";" . $active . "\n";
        }
    }
}

echo "<pre>" . $exportText . "</pre>";
if ($exportFiles) {
    file_put_contents($exportPath . $exportName . ".links", $exportText);
}


echo "\n\n<br><br>====================================";

echo "<pre>";
echo print_r($json);
echo "</pre>";

?>